/******************************************************************************
Copyright (C) 2011-2012 Linagora

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version, provided you comply with the Additional Terms applicable for OBM
connector by Linagora pursuant to Section 7 of the GNU Affero General Public
License, subsections (b), (c), and (e), pursuant to which you must notably (i)
retain the “Message sent thanks to OBM, Free Communication by Linagora”
signature notice appended to any and all outbound messages (notably e-mail and
meeting requests), (ii) retain all hypertext links between OBM and obm.org, as
well as between Linagora and linagora.com, and (iii) refrain from infringing
Linagora intellectual property rights over its trademarks and commercial
brands. Other Additional Terms apply, see <http://www.linagora.com/licenses/>
for more details.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License and
its applicable Additional Terms for OBM along with this program. If not, see
<http://www.gnu.org/licenses/> for the GNU Affero General   Public License
version 3 and <http://www.linagora.com/licenses/> for the Additional Terms
applicable to OBM connectors.
******************************************************************************/



/*
 * Globals
 */

var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
.getService(Components.interfaces.nsIPromptService);

/*
 * Scritps
 */
Components.utils.import("resource://obm-extension/modules/UtilsOBM.jsm");
Components.utils.import("resource://obm-extension/modules/GlobalData.jsm");
Components.utils.import("resource://calendar/modules/calUtils.jsm");

// Init logger
var gLogger = Components.classes["@obm.org/calendar/logger;1"].createInstance(Components.interfaces.obmILogger);
var writer = Components.classes["@obm.org/calendar/writer;1?type=unixfile"].getService(Components.interfaces.obmILoggerWriter);
gLogger.setLevelWriter(gLogger.LOAD_LEVEL, writer);
gLogger.setHeader("=== extension.js: ");


/*
 * Functions
 */
function OBM_ShowLog() {
  let fileName = UtilsOBM.getPrefSafe("extensions.obm.log.file") || "obm-connector-log.txt";

  var file = Components.classes["@mozilla.org/file/directory_service;1"].
    getService(Components.interfaces.nsIProperties).
    get("ProfD", Components.interfaces.nsIFile);
  file.QueryInterface(Components.interfaces.nsILocalFile);
  file.append(fileName);
  try {
    file.launch();
  } catch(e) {
    try {
      var uri = Components.classes["@mozilla.org/network/io-service;1"].
        getService(Components.interfaces.nsIIOService).
        newFileURI(file);
      var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].
        getService(Components.interfaces.nsIExternalProtocolService);
      protocolSvc.loadUrl(uri);
    } catch(e) {
      alert(e);
    }
  }
}

function OBM_getTicket(){
	let obmUrl = UtilsOBM.getPrefSafe("extensions.obm.obmUrl");
	var dealerUrl = obmUrl + "/sso/sso_index.php?action=ticket&mode=interactive";
	var httpRequest = XMLHttpRequest();

	var username = {};
	var password = {};
	if ( !UtilsOBM.getOBMCredentials(username, password)
		|| username.value == ""
		|| password.value == ""
		|| password.value == UtilsOBM.PASSWORD_NOT_CONFIGURED) {
		if (username.value == undefined || username.value == "") {
			var title = UtilsOBM.getLocalizedMessage("obmconf");
			var message = UtilsOBM.getLocalizedMessage("obmconfcredentials");
			promptService.alert(window, title, message);

			if (UtilsOBM.showWindow("preferences/connection.xul", window))
				return OBM_getTicket();
			else
				return null;
		} else {
			// prompt only for password
			if (!UtilsOBM.showWindow("preferences/password.xul", window))
				return null;
			if (UtilsOBM.getTemporaryPassword(password) == false) {
				return null//;OBM_getTicket();
			}
		}
	}

	httpRequest.open('POST', dealerUrl, false);
	httpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	try {
		var params = "login=" + encodeURIComponent( username.value )
		+ "&password=" + encodeURIComponent( password.value );
		//dump("params:"+params+"\n");
		httpRequest.send(params);
	} catch (e) {
		throw e;
	}
	var httpResponse = {
		status: httpRequest.status,
		statusText: httpRequest.statusText,
		responseXML: httpRequest.responseText
	};
	//dump("resp:"+httpResponse.responseXML+"\n");
	if (!httpResponse.responseXML.match("ticket=[:print:]*")) {
		throw new Error('noTicket');
	}
	return httpResponse.responseXML;
}

function OBM_OpenLink(aPage) {
	// suppress external-load warning for standard browser schemes
	UtilsOBM.setPrefSafe("network.protocol-handler.warn-external.http", false);
	UtilsOBM.setPrefSafe("network.protocol-handler.warn-external.https", false);

	let obmUrl = UtilsOBM.getPrefSafe("extensions.obm.obmUrl", "");
	if (obmUrl == "") {
		var title = UtilsOBM.getLocalizedMessage("obmconf");
		var message = UtilsOBM.getLocalizedMessage("obmconfobmweb");
		promptService.alert(window, title, message);
		if (UtilsOBM.showWindow("preferences/connection.xul", window))
			return OBM_OpenLink(aPage);
		else
			return null;
	}
	
	let ticket = null;
	let sso = UtilsOBM.getPrefSafe("extensions.obm.sso", false);

	if (sso) {
		try {
			ticket = OBM_getTicket();
		} catch (e) {
			if (e.message == 'noTicket') {
				UtilsOBM.showAlert("authenticationfailed");
			} else {
				UtilsOBM.showAlert("connectionfailed");
			}
			return null;
		}
		
		if (!ticket || ticket.indexOf("=") == -1) {
			return null;
		} else {
		    ticket = ticket.split("=")[1];
		}
	}

	let urlPath,
	    params = [];

	switch (aPage) {
	  case "obm-web-agenda":
	    urlPath = "/calendar/calendar_index.php";
	    params.push("action=waiting_events");
	    break;
	  case "obm-web-account":
	    urlPath = "/settings/settings_index.php";
	    break;
	  default:
	    return null;
	}

	if (ticket) {
	  params.push("auth_ticket=" + ticket);
	}

	let pageURL = obmUrl + urlPath + (params.length ? "?" + params.join("&") : "");

	var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uriToOpen = ioservice.newURI(pageURL, null, null);
	var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
	// now, open it!
	extps.loadURI(uriToOpen, null);
	return null;
}

function OBM_Synchronize() {
    let syncManager = UtilsOBM.getSyncManager();
    syncManager.syncWithDialog(window);
}

/* Synchronization Window */

function OBM_LoadSynchronizationSettings() {
  document.getElementById("override").value = UtilsOBM.getPrefSafe("extensions.obm.override", "");
  document.getElementById("contactRefresh").value = UtilsOBM.getPrefSafe("extensions.obm.contact.autorefresh.timeout", "");
  document.getElementById("calendarRefresh").value = UtilsOBM.getPrefSafe("extensions.obm.calendar.autorefresh.timeout", "");
  document.getElementById("syncOnStart").checked = UtilsOBM.getPrefSafe("extensions.obm.syncOnStart", true);
  document.getElementById("syncOnQuit").checked = UtilsOBM.getPrefSafe("extensions.obm.syncOnQuit", false);
  document.getElementById("proactiveSync").checked = UtilsOBM.getPrefSafe("extensions.obm.proactiveSync", false);
  document.getElementById("firstSyncDelay").value = UtilsOBM.getPrefSafe("extensions.obm.firstSyncDelay", "0");
  document.getElementById("syncAllEvents").checked = UtilsOBM.getPrefSafe("extensions.obm.calendar.syncrange.full", false);
  document.getElementById("syncRecentEvents").value = UtilsOBM.getPrefSafe("extensions.obm.calendar.syncrange.maxMonths", "3");
  
  OBM_UpdateSyncOnStartPreferences();
  OBM_UpdateSyncIntervalPreferences();
}

function OBM_validateMaximumDelay() {
  if (!document.getElementById("syncOnStart").checked) {
      setDelayPrompt(true);
      
      return;
  }
  
  let autoRefresh = document.getElementById("calendarRefresh").value;
  let initDelay = document.getElementById("firstSyncDelay").value;

  function setDelayPrompt(valid) {
    document.getElementById("firstSyncDelayPrompt").setAttribute("hidden", valid ? "true" : "false");
    document.documentElement.getButton("accept").disabled = !valid;
  }

  setDelayPrompt(UtilsOBM.parseIntWithDefault(initDelay, 10, 0) < UtilsOBM.parseIntWithDefault(autoRefresh, 10, 0));
}

function OBM_SaveSynchronizationSettings() {
  UtilsOBM.setPrefSafe("extensions.obm.override", document.getElementById("override").selectedItem.value);
  UtilsOBM.setPrefSafe("extensions.obm.contact.autorefresh.timeout", UtilsOBM.parseIntWithDefault(document.getElementById("contactRefresh").value, 10, 0));
  
  var crefresh = UtilsOBM.parseIntWithDefault(document.getElementById("calendarRefresh").value, 10, 0);
  var calendars = UtilsOBM.getSubscribedOBMCalendar();

  for each ( let calendar in calendars ) {
      calendar.setProperty("refreshInterval", crefresh);
  }
  
  let oldSyncRangeFull = UtilsOBM.getPrefSafe("extensions.obm.calendar.syncrange.full", false);
  let oldSyncRangeMaxMonths = UtilsOBM.getPrefSafe("extensions.obm.calendar.syncrange.maxMonths", "3");
  let syncRangeFull = document.getElementById("syncAllEvents").checked;
  let syncRangeMaxMonths = UtilsOBM.parseIntWithDefault(document.getElementById("syncRecentEvents").value, 10, 0);
  
  UtilsOBM.setPrefSafe("extensions.obm.calendar.autorefresh.timeout", crefresh);
  UtilsOBM.setPrefSafe("extensions.obm.syncOnStart", document.getElementById("syncOnStart").checked);
  UtilsOBM.setPrefSafe("extensions.obm.syncOnQuit", document.getElementById("syncOnQuit").checked);
  UtilsOBM.setPrefSafe("extensions.obm.proactiveSync", document.getElementById("proactiveSync").checked);
  UtilsOBM.setPrefSafe("extensions.obm.firstSyncDelay", UtilsOBM.parseIntWithDefault(document.getElementById("firstSyncDelay").value, 10, 0));
  UtilsOBM.setPrefSafe("extensions.obm.calendar.syncrange.full", syncRangeFull);
  UtilsOBM.setPrefSafe("extensions.obm.calendar.syncrange.maxMonths", syncRangeMaxMonths);
  
  // We should reset the calendars if the user changed the sync range properties
  if (oldSyncRangeFull != syncRangeFull || oldSyncRangeMaxMonths != syncRangeMaxMonths) {
      for each ( let calendar in calendars ) {
          calendar.setProperty("X-OBM-SYNCRANGE-CHANGED", true);
      }
      UtilsOBM.setPrefSafe("extensions.obm.calendar.resourcesSyncRangeUpdated", true);
  }
}

/* Reset Button */
function OBM_Reset(partial,cb) {
	if ( !partial ) {
		// delete account
		gLogger.debug("Reset - deleting pref 'extensions.obm.server'", false, false);
		UtilsOBM.deletePreferenceBranch("extensions.obm.server");
		gLogger.debug("Reset - deleting pref 'extensions.obm.obmUrl'", false, false);
		UtilsOBM.deletePreferenceBranch("extensions.obm.obmUrl");
		gLogger.debug("Reset - reseting credentials", false, false);
		UtilsOBM.resetOBMCredentials();
		gLogger.debug("Reset - deleting branch 'extensions.obm.autoconf'", false, false);
		UtilsOBM.deletePreferenceBranch("extensions.obm.autoconf");
	}
	UtilsOBM.reset(cb);
}

/*
 * only reset server connection parameters :
 * obm server, url, login & password
 */
function OBM_ResetAccount( ) {
	gLogger.debug("Reset - deleting pref 'extensions.obm.server'", false, false);
	UtilsOBM.deletePreferenceBranch("extensions.obm.server");
	gLogger.debug("Reset - deleting pref 'extensions.obm.obmUrl'", false, false);
	UtilsOBM.deletePreferenceBranch("extensions.obm.obmUrl");
	gLogger.debug("Reset - reseting credentials", false, false);
	UtilsOBM.resetOBMCredentials();
	gLogger.debug("Reset - deleting branch 'extensions.obm.autoconf'", false, false);
	UtilsOBM.deletePreferenceBranch("extensions.obm.autoconf");
	UtilsOBM.resetOBMCredentials();
}

function OBM_ImportCalendars() {
	var calendarManager = cal.getCalendarManager();

	var calendars = calendarManager.getCalendars({});
	for each ( var calendar in calendars ) {
		if ( calendar.type == "obm" ) {
			UtilsOBM.importCalendar(calendar);
		}
	}
}

function OBM_Purge() {
	gLogger.notice("Purge: purge asked by user", false, false);
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
		.getService(Components.interfaces.nsIPromptService);
	var title = UtilsOBM.getLocalizedMessage("obmpurgetitle");
	var message = UtilsOBM.getLocalizedMessage("obm.purge.confirm");
	if (!promptService.confirm(null, title, message)) {
		return;
	}

	let preff = UtilsOBM.getPrefSafe("extensions.obm.calEvents.is_sync_enabled", true);
	if (preff) {
		//ask for purge on personnal calendar
		var username = {};
		var password = {};
		if (!UtilsOBM.getOBMCredentials(username, password) || username.value == "") {
			//nothing
			gLogger.notice("Purge: user failed to authenticate. No purge performed.", false, false);
		} else {
			var calendarManager = cal.getCalendarManager();
            var syncManager = UtilsOBM.getSyncManager();
			var calendars = calendarManager.getCalendars({});
			for each(var calendar in calendars) {
				if (calendar.type == "obm") {
					UtilsOBM.removeAllCalendarSyncItems(calendar);
					var calName = calendarManager.getCalendarPref_(calendar, "X-OBM-NAME");
					if (calName == username.value.split("@")[0]) {
						gLogger.notice("Purge: Purging calendar \"" + calName + "\"", false, false);
						syncManager.purgeCalendar(calName);
					}
				} else {
					gLogger.notice("Purge: calendar \"" + calName + "\" is not of type 'OBM'. Skipping purge.", false, false);
				}
			}
		}
	} else {
		gLogger.notice("Purge: pref 'extensions.obm.calEvents.is_sync_enabled' set to false. No purge performed.", false, false);
	}
}

function OBM_UpdateNotificationPreference(selectedItem) {
  if ( selectedItem !== null ) {
    gLogger.debug("obmPrefs: item selected: "+selectedItem.value, false, false);
    UtilsOBM.setPrefSafe("extensions.obm.sendNotifications", selectedItem.value);
  }
}

function OBM_UpdateSyncOnStartPreferences() {
    var checkboxSyncOnStart = document.getElementById("syncOnStart");
    
    document.getElementById("firstSyncDelay").disabled = !checkboxSyncOnStart.checked;
    document.getElementById("firstSyncDelayPreLabel").disabled = !checkboxSyncOnStart.checked;
    document.getElementById("firstSyncDelayPostLabel").disabled = !checkboxSyncOnStart.checked;
}

function OBM_SyncAndUpdateRights() {
    let useGetCalendarMetadataBeforeSync = UtilsOBM.getPrefSafe("extensions.obm.rights.useGetCalendarMetadata");
    var username = {};
    var password = {};
    
    if (UtilsOBM.getOBMCredentials(username, password) &&
        username.value != "" &&
        password.value != "" &&
        password.value != UtilsOBM.PASSWORD_NOT_CONFIGURED) {

        var wWatcher = Components
                            .classes["@mozilla.org/embedcomp/window-watcher;1"]
                            .getService(Components.interfaces.nsIWindowWatcher);
        var params = Components
                        .classes["@mozilla.org/supports-array;1"]
                        .createInstance(Components.interfaces.nsISupportsArray);
        var observerService = Components
                                    .classes["@mozilla.org/observer-service;1"]
                                    .getService(Components.interfaces.nsIObserverService);
        
        // We revert to the previous pref value when the sync completes
        observerService.addObserver({
            observe: function () {
                UtilsOBM.setPrefSafe("extensions.obm.rights.useGetCalendarMetadata", useGetCalendarMetadataBeforeSync);
                observerService.removeObserver(this, "obmCalendarSyncCompleted");
            }   
        }, "obmCalendarSyncCompleted", false);

        UtilsOBM.setPrefSafe("extensions.obm.rights.useGetCalendarMetadata", true);
        wWatcher.openWindow(null, "chrome://obm-extension/content/sync-dialog.xul", "OBM_SYNCHRO", "modal,centerscreen,chrome,resizable=no,dialog", params);
    }
}

function OBM_UpdateSyncIntervalPreferences() {
    var checkboxSyncAllEvents = document.getElementById("syncAllEvents");
    
    document.getElementById("syncRecentEvents").disabled = checkboxSyncAllEvents.checked;
    document.getElementById("syncRecentEventsPreLabel").disabled = checkboxSyncAllEvents.checked;
    document.getElementById("syncRecentEventsPostLabel").disabled = checkboxSyncAllEvents.checked;
}
