/******************************************************************************
Copyright (C) 2011-2012 Linagora

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version, provided you comply with the Additional Terms applicable for OBM
connector by Linagora pursuant to Section 7 of the GNU Affero General Public
License, subsections (b), (c), and (e), pursuant to which you must notably (i)
retain the “Message sent thanks to OBM, Free Communication by Linagora”
signature notice appended to any and all outbound messages (notably e-mail and
meeting requests), (ii) retain all hypertext links between OBM and obm.org, as
well as between Linagora and linagora.com, and (iii) refrain from infringing
Linagora intellectual property rights over its trademarks and commercial
brands. Other Additional Terms apply, see <http://www.linagora.com/licenses/>
for more details.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License and
its applicable Additional Terms for OBM along with this program. If not, see
<http://www.gnu.org/licenses/> for the GNU Affero General   Public License
version 3 and <http://www.linagora.com/licenses/> for the Additional Terms
applicable to OBM connectors.
******************************************************************************/

const HTML_NS = "http://www.w3.org/1999/xhtml";
const Ci = Components.interfaces;

var currentUL = null;
var currentLI = null;
var currentH2 = null;

var stringBundle;

var obs = null;

Components.utils.import("resource://obm-extension/modules/UtilsOBM.jsm");

function getLocalizedMessage(aString) {
	try {
		return stringBundle.GetStringFromName("obm.sync."+aString);
	} catch(e) {
		return aString;
	}
}

function notifyBeforeClosing(aParam) {
	var label = document.documentElement.getButton("accept").label;
	regExp = /\(\d\d*\)/;
	if ( label.search(regExp) != -1 ) {
		label = label.replace(regExp, '(' + aParam.decount + ')');
	} else {
		label += " (" + aParam.decount + ")";
	}
	document.documentElement.getButton("accept").label = label;
	if ( aParam.decount<0 ) {
		window.close();
	}
	aParam.decount--;
}

function done(aSuccess) {
	var tb = document.getElementById("mainThrobber");
	tb.style.visibility= "collapse";
	if (aSuccess) {
		var ll = document.getElementById("resultLabel");
		ll.style.visibility = "visible";
	}
	window.enableAccept();
	if (aSuccess) {
		// Automatically close the window after 3 seconds
		this.decount = 3;
		notifyBeforeClosing(this);
		setInterval(notifyBeforeClosing, 1000, this);
	}
}

function SyncObserver() {}
SyncObserver.isSecondPass = false;
SyncObserver.prototype = {
	observe: function(subject, topic, data) {
		switch(data) {
			case "newOperation":
				var opName = subject.wrappedJSObject.opName;
				
				switch(opName) {
					case "logUserIn":
					this.curOpName = "login";
						document.getElementById(this.curSet+"Status").value = getLocalizedMessage(this.curOpName) + " ...";
						break;
					case "getSync":
						this.curOpName = "checking";
						break;
					case "mergeRemoteDiff":
						this.curOpName = "merging";
						document.getElementById(this.curSet+"Status").value = getLocalizedMessage(this.curOpName) + " ...";
						break;
					case "sendLocalDiff":
						this.curOpName = "sending";
						break;
					case "listCategories":
						this.curOpName = "merging";
						break;
					case "cleaning":
					    this.curOpName = "cleaning";
					    document.getElementById(this.curSet+"Status").value = getLocalizedMessage(this.curOpName) + " ...";
					default :
				}
				break;
			case "operationDone":
				document.getElementById(this.curSet+"Status").value = "";
				break;
			case "newOperationSet":
				var msg = subject.wrappedJSObject;
				this.curSet = msg.opSetName;
				document.getElementById(this.curSet+"Box").setAttribute("hidden", false);
				break;
			case "operationSetError":
				var msg = subject.wrappedJSObject.message;
				document.getElementById(this.curSet+"Status").value = msg;
				break;
			case "operationSetErrorFatal":
				var msg = subject.wrappedJSObject.message;
				if ( this.curSet == "cal" ) {
					var widget = document.getElementById(this.curSet+"StatusError");
					document.getElementById("progressBox").firstChild.style.display="none";
					widget.appendChild( document.createTextNode(msg) );
					widget.style.color="red";
					widget.style.display="block";
					
				} else {
					document.getElementById(this.curSet+"Status").value = msg;
					document.getElementById(this.curSet+"Status").style.color = "red";
				}
				done(false);
				// Avoid calling 'done()' more than once
				this.unregister();
				break;
			case "operationSetDone":
				document.getElementById(this.curSet+"Status").value = "ok";
				break;
			case "syncDone":
				done(true);
				// Avoid calling 'done()' more than once
				this.unregister();
				break;
			case "operationProgress":
				var msg = subject.wrappedJSObject;
				document.getElementById(this.curSet+"Name").value = msg.entity;
				document.getElementById(this.curSet+"Status").value = 
					getLocalizedMessage(this.curOpName) +" : " + msg.idx + "/" + msg.total + " " + getLocalizedMessage(msg.type) +" ...";
				dump(this.curOpName +" : " + msg.idx + "/" + msg.total + " " + msg.type +" ...\n");
				break;
			default:
		}
	},
	register: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(this, "verbose-obm-sync-progress", false);
	},
	unregister: function() {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(this, "verbose-obm-sync-progress");
	}
}

function synchronizeAll() {
	UtilsOBM.getSyncManager().syncAll();
}

function onStart() {
	obs = new SyncObserver();
	obs.register();
	stringBundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
	 	.getService(Components.interfaces.nsIStringBundleService)
	 	.createBundle("chrome://obm-extension/locale/errors_warnings.properties");
	var ll = document.getElementById("resultLabel");
	ll.style.visibility = "collapse";
	setTimeout(synchronizeAll, 100);   	
}

function onUnload() {
	obs.unregister();
}

window.addEventListener("load", onStart, false);
window.addEventListener("unload", onUnload, false);
