var EXPORTED_SYMBOLS = ["Paginer"];

var Paginer = function(method, limit, pattern, fetcher) {
  this.method = method;
  this.limit = limit;
  this.offset = 0;
  this.mPattern = pattern;
  this.endOfResult = false;
  this.fetcher = fetcher;
};

Paginer.prototype = {
  get pattern() { return this.mPattern; },
  set pattern(pattern) {
    this.mPattern = pattern;
    this.offset = 0;
    this.endOfResult = false;
  }
};

Paginer.prototype.setOffset = function(offset){
  this.offset = offset;
}

Paginer.prototype.fetchNextItems = function(callback) {
  if (this.endOfResult){
    return;
  }
  var self = this;

  this.fetcher(this.method, this.limit + 1, this.offset, this.mPattern, function(error, result){
    if(error){
      callback(error);
      return;
    }

    var calendars = result.QueryInterface(Components.interfaces.nsIMutableArray);
    var length = calendars.length;

    if (length < (self.limit + 1)) {
      self.endOfResult = true;
    } else {
      self.endOfResult = false;
      self.offset += self.limit;
      calendars.removeElementAt(self.limit);
    }

    callback(null, calendars);
  });
};